



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python 实现的随机森林</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python 实现的随机森林</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 12:13:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://en.wikipedia.org/wiki/Random_forest" rel="external nofollow noreferrer">随机森林</a>是一个高度灵活的机器学习方法，拥有广泛的应用前景，从市场营销到医疗保健保险。 既可以用来做<a href="http://epubl.ltu.se/1653-0187/2008/014/LTU-PB-EX-08014-SE.pdf" rel="external nofollow noreferrer">市场营销模拟的建模</a>，统计客户来源，保留和流失。也可用来<a href="http://www.biomedcentral.com/1472-6947/11/51" rel="external nofollow noreferrer">预测疾病的风险</a>和病患者的易感性。</p>
<p>随机森林是一个可做能够回归和分类。 它具备处理大数据的特性，而且它有助于估计或变量是非常重要的基础数据建模。</p>
<p>这是一篇关于使用Python来实现随机森林文章。</p>
<h3>什么是随机森林？</h3>
<p>随机 森林 是 几乎 任何 预测 问题 (甚至 非直线 部分) 的固有 选择 。 它是 一个 相对较 新 的 机器 学习 的 策略 （ 在90 年代产生于 贝尔 实验室 ) 和 它 可以 几乎用于 任何方面 。 它 属于 机器 学习 算法 一大类----- 集成学习 方法 。</p>
<div>
<div>
<h5>集成学习</h5>
</div>
<p>集成学习通过建立几个模型组合的来解决单一预测问题。它的工作原理是生成多个分类器/模型，各自独立地学习和作出预测。这些预测最后结合成单预测，因此优于任何一个单分类的做出预测。</p>
<div>
<p>随机森林是集成学习的一个子类，由于它依靠于策率树的合并。你可以在这找到用python实现集成学习的文档：<a href="http://scikit-learn.org/dev/modules/ensemble.html" rel="external nofollow noreferrer">Scikit 学习文档</a>。</p>
</div>
</div>
<h5>随机决策树</h5>
<p>我们 知道 随机 森林 是 其他 的模型 聚合， 但 它 聚合 了什么 类型 模型 ？ 你 可能 已经 从 其 名称 、 随机 森林 聚合 分类（或 回归） 的 树 中猜到。 决策 树 是 由 一 系列 的 决策的组合， 可 用于 分类 观察 数据集 。</p>
<h5>随机森林</h5>
<p>算法引入了一个随机森林来 自动 创建 随机 决策 树 群 。 由于 树 随机 生成 的树， 大部分的树(或许 99.9%树) 不 会 对 学习 的 分类/回归 问题 都 有意义 。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232437-b18a13d2aeed4a6292d3f07ec1ac489e.x-png" /></p>
<p>如果 观察到 长度 为 45 ，蓝 眼睛 ， 和 2 条腿 ， 就 被 归类 为 <strong>红色</strong> 。</p>
<h5>树的投票</h5>
<p>所以10000个（概率上）糟糕的模型有TMD什么好的？好吧，这样确实没什么特别的好处。但是随着很多糟糕的决策树被生成，其中也会有很少确实很优秀的决策树。</p>
<p>当你要做预测的时候，新的观察到的特征随着决策树自上而下走下来，这样一组观察到的特征将会被贴上一个预测值/标签。一旦森林中的每棵树都给出了预测值/标签，所有的预测结果将被归总到一起，所有树的模式投票被返回做为最终的预测结果。</p>
<p>简单来说，99.9%不相关的树做出的预测结果涵盖所有的情况，这些预测结果将会彼此抵消。少数优秀的树的预测结果将会超脱于芸芸&ldquo;噪音&rdquo;，做出一个好的预测。</p>
<h3><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232519-1f3cc59ae72f4653b57a9680e537788d.x-png" /></h3>
<h3>为什么你让我用它？</h3>
<h5>简单</h5>
<p>随机森林就是学习方法中的<a href="http://www.leatherman.com/product/Super_Tool_300" rel="external nofollow noreferrer">Leatherman</a>呀。你几乎可以把任何东西扔进去，它基本上都是可供使用的。在估计推断映射方面特别好用，以致都不需要像SVM那样做很多调试（也就是说对于那些最后期限很紧的家伙们真是太棒了）。</p>
<p>[译者注：Leatherman就是那家生产多功能折叠刀的公司，类似瑞士军刀]</p>
<h5>一个映射的例子</h5>
<p>随机森林在没有精心准备的数据映射的情况下也能学习。以方程f(x) = log(x)为例。</p>
<p>制造一些假数据，并且加上一点儿噪音。</p>
<pre class="prettyprint linenums">import numpy as np<br />
x = np.random.uniform(1, 100, 1000)<br />
y = np.log(x) + np.random.normal(0, .3, 1000)</pre>
<p><a href="https://gist.github.com/glamp/5716253" rel="external nofollow noreferrer">full gist here</a> <img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232554-7b873d6716d24341873d87b45a20846f.x-png" /></p>
<p>如果 我们 建立了 一个 基本 的 线性 模型 通过使用 x 来预测y， 我们需要 作 一 条 直线 ， 算是 平分 log (x) 函数。 而 如果 我们 使用 一个 随机 的 森林 ， 它 不会 更 好 的 逼近 log (x) 曲线 并能够使得它更像实际函数。&nbsp;<br /><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232623-c2f2b48e85a545e1b3da13968119bdaf.x-png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232706-19872199367441a4a58989097c6ffc78.x-png" /></p>
<p>你 也许会说 随机 森林 有点 扰乱了 log(x) 函数 。 不管怎样 ， 我 都认为 这 做了一个 很 好 的 说明 如何 随机 森林 并 未绑定于 线性 约束 。</p>
<h3>使用</h3>
<h5>变量选择</h5>
<p>随机森林最好的用例之一是特征选择。尝试很多决策树变种的一个副产品就是你可以检测每棵树中哪个变量最合适/最糟糕。</p>
<p>当一棵树使用一个变量，而另一棵不使用这个变量，你就可以从是否包含这个变量来比较价值的减少或增加。优秀的随机森林实现将为你做这些事情，所以你需要做的仅仅是知道去看那个方法或参数。</p>
<p>在下述的例子中，我们尝试去指出对于将酒分为红酒或者白酒哪个变量是最重要的。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232802-e524cd3bb5014b06a43c9ccc74257df2.x-png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232816-b8a394d8d0384b0fa209b8f37c163ad3.x-png" /></p>
<p><strong>分类</strong></p>
<p>随机森林也很善于分类。它可以被用于为多个可能目标类别做预测，它也可以被校正输出概率。你需要注意的一件事情是<a href="http://en.wikipedia.org/wiki/Overfitting" rel="external nofollow noreferrer">过拟合</a>。随机森林容易产生过拟合，特别是在数据集相对小的时候。当你的模型对于测试集合做出&ldquo;太好&rdquo;的预测的时候就应该怀疑一下了。</p>
<p>产生过拟合的一个原因是在模型中只使用相关特征。然而只使用相关特征并不总是事先准备好的，使用特征选择（就像前面提到的）可以使其更简单。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232851-453d72d118db4ad7949e4fc5ffe64df4.x-png" /></p>
<p><strong>回归</strong></p>
<p>是的，它也可以做回归。</p>
<p>我们已经发现随机森林&mdash;&mdash;不像其它算法&mdash;&mdash;对分类变量或者分类变量和真实变量混合学习的非常好。具有高基数（可能值的#）的分类变量是很棘手的，所以在你的口袋中放点儿这样的东西将会是非常有用的。</p>
<h3>一个简短的python例子</h3>
<p>Scikit-Learn是开始使用随机森林的一个很好的方式。scikit-learn API在所以算法中极其的一致，所有你测试和在不同的模型间切换非常容易。很多时候，我从一些简单的东西开始，然后转移到了随机森林。</p>
<p>随机森林在scikit-learn中的实现最棒的特性是n_jobs参数。这将会基于你想使用的核数自动地并行设置随机森林。这里是scikit-learn的贡献者Olivier Grisel的一个很棒的<a href="http://vimeo.com/63269736" rel="external nofollow noreferrer">报告</a>，在这个报告中他谈论了使用20个节点的EC2集群训练随机森林。</p>
<div>
<div>
<div><a href="http://www.open-open.com/lib/view/open1370959543195.html#viewSource" rel="external nofollow noreferrer">查看源码</a></p>
<div>&nbsp;</div>
<p><a href="http://www.open-open.com/lib/view/open1370959543195.html#printSource" rel="external nofollow noreferrer">打印</a><a href="http://www.open-open.com/lib/view/open1370959543195.html#about" rel="external nofollow noreferrer">?</a></div>
</div>
<div>
<div>
<table>
<tbody>
<tr>
<td><code>01</code></td>
<td><code>from</code> <code>sklearn.datasets </code><code>import</code> <code>load_iris </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>02</code></td>
<td><code>from</code> <code>sklearn.ensemble </code><code>import</code> <code>RandomForestClassifier </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>03</code></td>
<td><code>import</code> <code>pandas as pd </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>04</code></td>
<td><code>import</code> <code>numpy as np </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>05</code></td>
<td><code>&nbsp;</code>&nbsp;</td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>06</code></td>
<td><code>iris </code><code>=</code> <code>load_iris() </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>07</code></td>
<td><code>df </code><code>=</code> <code>pd.DataFrame(iris.data, columns</code><code>=</code><code>iris.feature_names) </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>08</code></td>
<td><code>df[</code><code>'is_train'</code><code>] </code><code>=</code> <code>np.random.uniform(</code><code>0</code><code>, </code><code>1</code><code>, </code><code>len</code><code>(df)) &lt;</code><code>=</code> <code>.</code><code>75</code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>09</code></td>
<td><code>df[</code><code>'species'</code><code>] </code><code>=</code> <code>pd.Factor(iris.target, iris.target_names) </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>10</code></td>
<td><code>df.head() </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>11</code></td>
<td><code>&nbsp;</code>&nbsp;</td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>12</code></td>
<td><code>train, test </code><code>=</code> <code>df[df[</code><code>'is_train'</code><code>]</code><code>=</code><code>=</code><code>True</code><code>], df[df[</code><code>'is_train'</code><code>]</code><code>=</code><code>=</code><code>False</code><code>] </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>13</code></td>
<td><code>&nbsp;</code>&nbsp;</td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>14</code></td>
<td><code>features </code><code>=</code> <code>df.columns[:</code><code>4</code><code>] </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>15</code></td>
<td><code>clf </code><code>=</code> <code>RandomForestClassifier(n_jobs</code><code>=</code><code>2</code><code>) </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>16</code></td>
<td><code>y, _ </code><code>=</code> <code>pd.factorize(train[</code><code>'species'</code><code>]) </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>17</code></td>
<td><code>clf.fit(train[features], y) </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>18</code></td>
<td><code>&nbsp;</code>&nbsp;</td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>19</code></td>
<td><code>preds </code><code>=</code> <code>iris.target_names[clf.predict(test[features])] </code></td>
</tr>
</tbody>
</table>
</div>
<div>
<table>
<tbody>
<tr>
<td><code>20</code></td>
<td><code>pd.crosstab(test[</code><code>'species'</code><code>], preds, rownames</code><code>=</code><code>[</code><code>'actual'</code><code>], colnames</code><code>=</code><code>[</code><code>'preds'</code><code>])</code></td>
</tr>
</tbody>
</table>
</div>
</div>
</div>
<p>看起来很不错！</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/541660/201308/29232935-9dbbae16f45b42f2a007449626ccdeee.x-png" /></p>
<h3>结语</h3>
<p>随机森林相当容易使用，而且很强大。对于任何建模，都要注意过拟合。如果你有兴趣用R语言开始使用随机森林，那么就签出<a href="http://cran.r-project.org/web/packages/randomForest/randomForest.pdf" rel="external nofollow noreferrer">randomForest</a>包。</p>
<div>
<p>本文地址：<a href="http://www.oschina.net/translate/random-forests-in-python" rel="external nofollow noreferrer">http://www.oschina.net/translate/random-forests-in-python</a></p>
<p>原文地址：<a href="http://blog.yhathq.com/posts/random-forests-in-python.html" rel="external nofollow noreferrer">http://blog.yhathq.com/posts/random-forests-in-python.html</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390m2438.html">C语言 活动安排问题之二</a>
		</li>
						<li><a href="https://www.batexi.com/a/495vl10q.html">git rebase简介&lpar;高级篇&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8orem18.html">ie11媒体查询以及其他hack</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eny5x8.html">狮子和计算Java题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rddy3e8.html">JQuery Ajax 的简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnlyorq.html">桶排序-OC</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmgjd79.html">IO负载高的来源定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2eex9.html">win7禁止自动使用浏览器打开FTP而是用资源管理器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdemyp09.html">C&num; DataTable的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memg2oq.html">opencv视频播放</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yj57z8.html">cell选中与取消选中调用的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jzw1x8.html">Python 字典&lpar;Dictionary&rpar; has&lowbar;key&lpar;&rpar;方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w667gq.html">&OpenCurlyDoubleQuote;一切都是消息&rdquo;--iMSF（即时消息服务框架）之【发布-订阅】模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j17r0q.html">confd</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7or2gk8.html">2&period;33 定位的坑：class属性有空格</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o6oge8.html">linux下mysql开启远程访问权限 防火墙开放3306端口</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pw56z8.html">使用 RestTemplate 调用 restful 服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/963lwy49.html">ZT  Android4&period;2蓝牙基础架构学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o43m0lq.html">P2245 星际导航</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveny6o9.html">MyEclipse项目如何导入到Eclipse</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jzvmww8.html">robot framework 牛刀一试</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo6jg3q.html">RSA算法介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk6e7z8.html">hdu 2066 最短路水题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljwk7x9.html">Java的构造器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gezge48.html">自制EIGRP配置实验大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z2d7j9.html">即时作图新工具&mdash;ProcessOn【推荐】</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m4l2j8.html">201521123073 《Java程序设计》第12周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpgljvq.html">201521123095 《Java程序设计》第10周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meyzw0q.html">201521123051《Java程序设计》第十二周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy16lemq.html">python面向对象之封装</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
